Module javafx.graphics
Package javafx.scene.shape

# Class Shape3D

java.lang.Object
javafx.scene.Node
javafx.scene.shape.Shape3D

All Implemented Interfaces:
  `Styleable`, `EventTarget`

Direct Known Subclasses:
  `Box`, `Cylinder`, `MeshView`, `Sphere`

public abstract class Shape3D extends Node
The `Shape3D` base class provides definitions of common properties for objects that represent some form of 3D geometric shape. These properties include:

- The `Material` to be applied to the fillable interior of the shape or the outline of the shape (see `setMaterial(javafx.scene.paint.Material)`).
- The draw model properties that defines how to render its geometry (see `setDrawMode(javafx.scene.shape.DrawMode)`).
- The face culling properties that defines which face to cull (see `setCullFace(javafx.scene.shape.CullFace)`).

Note that this is a conditional feature. See `ConditionalFeature.SCENE3D` for more information.

An application should not extend the Shape3D class directly. Doing so may lead to an UnsupportedOperationException being thrown.

Since:
  JavaFX 8.0

## Property Summary

Properties
Type
Property
Description
`final ObjectProperty<CullFace>`
`cullFace`
Defines the cullFace this `Shape3D`.
`final ObjectProperty<DrawMode>`
`drawMode`
Defines the draw mode used to render this `Shape3D`.
`final ObjectProperty<Material>`
`material`
Defines the material this `Shape3D`.

### Properties inherited from class javafx.scene.Node

`accessibleHelp, accessibleRoleDescription, accessibleRole, accessibleText, blendMode, boundsInLocal, boundsInParent, cacheHint, cache, clip, cursor, depthTest, disabled, disable, effectiveNodeOrientation, effect, eventDispatcher, focused, focusTraversable, hover, id, inputMethodRequests, layoutBounds, layoutX, layoutY, localToParentTransform, localToSceneTransform, managed, mouseTransparent, nodeOrientation, onContextMenuRequested, onDragDetected, onDragDone, onDragDropped, onDragEntered, onDragExited, onDragOver, onInputMethodTextChanged, onKeyPressed, onKeyReleased, onKeyTyped, onMouseClicked, onMouseDragEntered, onMouseDragExited, onMouseDragged, onMouseDragOver, onMouseDragReleased, onMouseEntered, onMouseExited, onMouseMoved, onMousePressed, onMouseReleased, onRotate, onRotationFinished, onRotationStarted, onScrollFinished, onScroll, onScrollStarted, onSwipeDown, onSwipeLeft, onSwipeRight, onSwipeUp, onTouchMoved, onTouchPressed, onTouchReleased, onTouchStationary, onZoomFinished, onZoom, onZoomStarted, opacity, parent, pickOnBounds, pressed, rotate, rotationAxis, scaleX, scaleY, scaleZ, scene, style, translateX, translateY, translateZ, viewOrder, visible`

## Field Summary

### Fields inherited from class javafx.scene.Node

`BASELINE_OFFSET_SAME_AS_HEIGHT`

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`Shape3D()`

## Method Summary

Modifier and Type
Method
Description
`final ObjectProperty<CullFace>`
`cullFaceProperty()`
Defines the cullFace this `Shape3D`.
`final ObjectProperty<DrawMode>`
`drawModeProperty()`
Defines the draw mode used to render this `Shape3D`.
`final CullFace`
`getCullFace()`
Gets the value of the `cullFace` property.
`final DrawMode`
`getDrawMode()`
Gets the value of the `drawMode` property.
`final Material`
`getMaterial()`
Gets the value of the `material` property.
`final ObjectProperty<Material>`
`materialProperty()`
Defines the material this `Shape3D`.
`final void`
`setCullFace(CullFace value)`
Sets the value of the `cullFace` property.
`final void`
`setDrawMode(DrawMode value)`
Sets the value of the `drawMode` property.
`final void`
`setMaterial(Material value)`
Sets the value of the `material` property.

### Methods inherited from class javafx.scene.Node

`accessibleHelpProperty, accessibleRoleDescriptionProperty, accessibleRoleProperty, accessibleTextProperty, addEventFilter, addEventHandler, applyCss, autosize, blendModeProperty, boundsInLocalProperty, boundsInParentProperty, buildEventDispatchChain, cacheHintProperty, cacheProperty, clipProperty, computeAreaInScreen, contains, contains, cursorProperty, depthTestProperty, disabledProperty, disableProperty, effectiveNodeOrientationProperty, effectProperty, eventDispatcherProperty, executeAccessibleAction, fireEvent, focusedProperty, focusTraversableProperty, getAccessibleHelp, getAccessibleRole, getAccessibleRoleDescription, getAccessibleText, getBaselineOffset, getBlendMode, getBoundsInLocal, getBoundsInParent, getCacheHint, getClassCssMetaData, getClip, getContentBias, getCssMetaData, getCursor, getDepthTest, getEffect, getEffectiveNodeOrientation, getEventDispatcher, getId, getInitialCursor, getInitialFocusTraversable, getInputMethodRequests, getLayoutBounds, getLayoutX, getLayoutY, getLocalToParentTransform, getLocalToSceneTransform, getNodeOrientation, getOnContextMenuRequested, getOnDragDetected, getOnDragDone, getOnDragDropped, getOnDragEntered, getOnDragExited, getOnDragOver, getOnInputMethodTextChanged, getOnKeyPressed, getOnKeyReleased, getOnKeyTyped, getOnMouseClicked, getOnMouseDragEntered, getOnMouseDragExited, getOnMouseDragged, getOnMouseDragOver, getOnMouseDragReleased, getOnMouseEntered, getOnMouseExited, getOnMouseMoved, getOnMousePressed, getOnMouseReleased, getOnRotate, getOnRotationFinished, getOnRotationStarted, getOnScroll, getOnScrollFinished, getOnScrollStarted, getOnSwipeDown, getOnSwipeLeft, getOnSwipeRight, getOnSwipeUp, getOnTouchMoved, getOnTouchPressed, getOnTouchReleased, getOnTouchStationary, getOnZoom, getOnZoomFinished, getOnZoomStarted, getOpacity, getParent, getProperties, getPseudoClassStates, getRotate, getRotationAxis, getScaleX, getScaleY, getScaleZ, getScene, getStyle, getStyleableParent, getStyleClass, getTransforms, getTranslateX, getTranslateY, getTranslateZ, getTypeSelector, getUserData, getViewOrder, hasProperties, hoverProperty, idProperty, inputMethodRequestsProperty, intersects, intersects, isCache, isDisable, isDisabled, isFocused, isFocusTraversable, isHover, isManaged, isMouseTransparent, isPickOnBounds, isPressed, isResizable, isVisible, layoutBoundsProperty, layoutXProperty, layoutYProperty, localToParent, localToParent, localToParent, localToParent, localToParent, localToParentTransformProperty, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToSceneTransformProperty, localToScreen, localToScreen, localToScreen, localToScreen, localToScreen, lookup, lookupAll, managedProperty, maxHeight, maxWidth, minHeight, minWidth, mouseTransparentProperty, nodeOrientationProperty, notifyAccessibleAttributeChanged, onContextMenuRequestedProperty, onDragDetectedProperty, onDragDoneProperty, onDragDroppedProperty, onDragEnteredProperty, onDragExitedProperty, onDragOverProperty, onInputMethodTextChangedProperty, onKeyPressedProperty, onKeyReleasedProperty, onKeyTypedProperty, onMouseClickedProperty, onMouseDragEnteredProperty, onMouseDragExitedProperty, onMouseDraggedProperty, onMouseDragOverProperty, onMouseDragReleasedProperty, onMouseEnteredProperty, onMouseExitedProperty, onMouseMovedProperty, onMousePressedProperty, onMouseReleasedProperty, onRotateProperty, onRotationFinishedProperty, onRotationStartedProperty, onScrollFinishedProperty, onScrollProperty, onScrollStartedProperty, onSwipeDownProperty, onSwipeLeftProperty, onSwipeRightProperty, onSwipeUpProperty, onTouchMovedProperty, onTouchPressedProperty, onTouchReleasedProperty, onTouchStationaryProperty, onZoomFinishedProperty, onZoomProperty, onZoomStartedProperty, opacityProperty, parentProperty, parentToLocal, parentToLocal, parentToLocal, parentToLocal, parentToLocal, pickOnBoundsProperty, prefHeight, prefWidth, pressedProperty, pseudoClassStateChanged, queryAccessibleAttribute, relocate, removeEventFilter, removeEventHandler, requestFocus, resize, resizeRelocate, rotateProperty, rotationAxisProperty, scaleXProperty, scaleYProperty, scaleZProperty, sceneProperty, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, screenToLocal, screenToLocal, screenToLocal, setAccessibleHelp, setAccessibleRole, setAccessibleRoleDescription, setAccessibleText, setBlendMode, setCache, setCacheHint, setClip, setCursor, setDepthTest, setDisable, setDisabled, setEffect, setEventDispatcher, setEventHandler, setFocused, setFocusTraversable, setHover, setId, setInputMethodRequests, setLayoutX, setLayoutY, setManaged, setMouseTransparent, setNodeOrientation, setOnContextMenuRequested, setOnDragDetected, setOnDragDone, setOnDragDropped, setOnDragEntered, setOnDragExited, setOnDragOver, setOnInputMethodTextChanged, setOnKeyPressed, setOnKeyReleased, setOnKeyTyped, setOnMouseClicked, setOnMouseDragEntered, setOnMouseDragExited, setOnMouseDragged, setOnMouseDragOver, setOnMouseDragReleased, setOnMouseEntered, setOnMouseExited, setOnMouseMoved, setOnMousePressed, setOnMouseReleased, setOnRotate, setOnRotationFinished, setOnRotationStarted, setOnScroll, setOnScrollFinished, setOnScrollStarted, setOnSwipeDown, setOnSwipeLeft, setOnSwipeRight, setOnSwipeUp, setOnTouchMoved, setOnTouchPressed, setOnTouchReleased, setOnTouchStationary, setOnZoom, setOnZoomFinished, setOnZoomStarted, setOpacity, setPickOnBounds, setPressed, setRotate, setRotationAxis, setScaleX, setScaleY, setScaleZ, setStyle, setTranslateX, setTranslateY, setTranslateZ, setUserData, setViewOrder, setVisible, snapshot, snapshot, startDragAndDrop, startFullDrag, styleProperty, toBack, toFront, toString, translateXProperty, translateYProperty, translateZProperty, usesMirroring, viewOrderProperty, visibleProperty`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface javafx.css.Styleable

`getStyleableNode`

## Property Details

### material

public final ObjectProperty<Material> materialProperty
Defines the material this `Shape3D`. The default material is null. If `Material` is null, a PhongMaterial with a diffuse color of Color.LIGHTGRAY is used for rendering.

Default value:
  null
See Also:
  - `getMaterial()`
  - `setMaterial(Material)`
  - `materialProperty()`

### drawMode

public final ObjectProperty<DrawMode> drawModeProperty
Defines the draw mode used to render this `Shape3D`. `DrawMode.LINE` is not available on embedded platforms. If `drawMode` is set to `DrawMode.LINE` on an embedded platform the default value of `DrawMode.FILL` will be used instead.

Default value:
  `DrawMode.FILL`
See Also:
  - `getDrawMode()`
  - `setDrawMode(DrawMode)`
  - `drawModeProperty()`

### cullFace

public final ObjectProperty<CullFace> cullFaceProperty
Defines the cullFace this `Shape3D`.

Default value:
  CullFace.BACK
See Also:
  - `getCullFace()`
  - `setCullFace(CullFace)`
  - `cullFaceProperty()`

## Constructor Details

### Shape3D

protected Shape3D()

## Method Details

### setMaterial

public final void setMaterial(Material value)
Sets the value of the `material` property.

Property description:
  Defines the material this `Shape3D`. The default material is null. If `Material` is null, a PhongMaterial with a diffuse color of Color.LIGHTGRAY is used for rendering.
Default value:
  null
Parameters:
  `value` - the value for the `material` property
See Also:
  - `getMaterial()`
  - `materialProperty()`

### getMaterial

public final Material getMaterial()
Gets the value of the `material` property.

Property description:
  Defines the material this `Shape3D`. The default material is null. If `Material` is null, a PhongMaterial with a diffuse color of Color.LIGHTGRAY is used for rendering.
Default value:
  null
Returns:
  the value of the `material` property
See Also:
  - `setMaterial(Material)`
  - `materialProperty()`

### materialProperty

public final ObjectProperty<Material> materialProperty()
Defines the material this `Shape3D`. The default material is null. If `Material` is null, a PhongMaterial with a diffuse color of Color.LIGHTGRAY is used for rendering.

Default value:
  null
Returns:
  the `material` property
See Also:
  - `getMaterial()`
  - `setMaterial(Material)`

### setDrawMode

public final void setDrawMode(DrawMode value)
Sets the value of the `drawMode` property.

Property description:
  Defines the draw mode used to render this `Shape3D`. `DrawMode.LINE` is not available on embedded platforms. If `drawMode` is set to `DrawMode.LINE` on an embedded platform the default value of `DrawMode.FILL` will be used instead.
Default value:
  `DrawMode.FILL`
Parameters:
  `value` - the value for the `drawMode` property
See Also:
  - `getDrawMode()`
  - `drawModeProperty()`

### getDrawMode

public final DrawMode getDrawMode()
Gets the value of the `drawMode` property.

Property description:
  Defines the draw mode used to render this `Shape3D`. `DrawMode.LINE` is not available on embedded platforms. If `drawMode` is set to `DrawMode.LINE` on an embedded platform the default value of `DrawMode.FILL` will be used instead.
Default value:
  `DrawMode.FILL`
Returns:
  the value of the `drawMode` property
See Also:
  - `setDrawMode(DrawMode)`
  - `drawModeProperty()`

### drawModeProperty

public final ObjectProperty<DrawMode> drawModeProperty()
Defines the draw mode used to render this `Shape3D`. `DrawMode.LINE` is not available on embedded platforms. If `drawMode` is set to `DrawMode.LINE` on an embedded platform the default value of `DrawMode.FILL` will be used instead.

Default value:
  `DrawMode.FILL`
Returns:
  the `drawMode` property
See Also:
  - `getDrawMode()`
  - `setDrawMode(DrawMode)`

### setCullFace

public final void setCullFace(CullFace value)
Sets the value of the `cullFace` property.

Property description:
  Defines the cullFace this `Shape3D`.
Default value:
  CullFace.BACK
Parameters:
  `value` - the value for the `cullFace` property
See Also:
  - `getCullFace()`
  - `cullFaceProperty()`

### getCullFace

public final CullFace getCullFace()
Gets the value of the `cullFace` property.

Property description:
  Defines the cullFace this `Shape3D`.
Default value:
  CullFace.BACK
Returns:
  the value of the `cullFace` property
See Also:
  - `setCullFace(CullFace)`
  - `cullFaceProperty()`

### cullFaceProperty

public final ObjectProperty<CullFace> cullFaceProperty()
Defines the cullFace this `Shape3D`.

Default value:
  CullFace.BACK
Returns:
  the `cullFace` property
See Also:
  - `getCullFace()`
  - `setCullFace(CullFace)`